/* This file is part of the FaCT++ DL reasoner
Copyright (C) 2006-2008 by Dmitry Tsarkov

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
*/

#include "JNISupport.h"

// check it pointer is a named concept
template<class T>
jlong getId ( T* p ATTR_UNUSED ) { return 0; }

//
template<>
jlong getId ( DLTree* p )
{
	switch ( p->Element().getToken() )
	{
	case TOP:		return 1;
	case BOTTOM:	return -1;
	case NAME:		return (jlong)p->Element().getName();
	default:		return 0;
	}
}

template<>
void registerPointer ( DLTree* p )
{
	assert(curKernel != NULL );
	curKernel->pRefRecorder->add(p);
}

