/* This file is part of the FaCT++ DL reasoner
Copyright (C) 2006-2007 by Dmitry Tsarkov

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
*/

#ifndef _EFPPCANTREGNAME_H
#define _EFPPCANTREGNAME_H

#include "eFaCTPlusPlus.h"

/// exception thrown in case name can't be registered
class EFPPCantRegName: public EFaCTPlusPlus
{
public:		// members
		/// error string
	std::string str;

public:		// interface
		/// c'tor: create an output string
	EFPPCantRegName ( const std::string& name, const std::string& type ) throw()
		: EFaCTPlusPlus()
	{
		str = "Unable to register '";
		str += name;
		str += "' as a ";
		str += type;
	}
		/// empty d'tor
	virtual ~EFPPCantRegName ( void ) throw() {}

		/// reason
	virtual const char* what ( void ) const throw() { return str.c_str(); }
}; // CantRegName

#endif


